MK-SLAVE-MOVE(1)

NAME
mk-slave-move - Move a MySQL slave around in the replication hierarchy.

SYNOPSIS
 mk-slave-move slave --sibling-of-master
 mk-slave-move slave --slave-of-sibling sibling
 mk-slave-move slave --slave-of-uncle uncle

RISKS
The following section is included to inform users about the potential risks, whether known or unknown, of using this tool. The two main categories of risks are those created by the nature of the tool (e.g. read-only tools vs. read-write tools) and those created by bugs.

mk-slave-move is a read-write tool by default. It manipulates replication settings. Some of the features are incomplete, including some safety checks such as not moving slaves that have temporary tables open.

At the time of this release, we know of no bugs that could cause serious harm to users.

The authoritative source for updated information is always the online issue tracking system. Issues that affect this tool will be marked as such. You can see a list of such issues at the following URL: <http://www.maatkit.org/bugs/mk-slave-move>.

See also "BUGS" for more information on filing bugs and getting help.

DESCRIPTION
This tool knows how to disconnect and reconnect slaves to each other, compare replication positions, and so on. This makes it able to move a slave around the replication hierarchy safely and correctly. It doesn't do anything you can't do by hand, but it is tedious and error-prone to do this by hand.

The hosts are given by a DSN. A DSN is a special syntax that can be either just a hostname (like "server.domain.com" or 1.2.3.4), or a "key=value,key=value" string. Keys are a single letter:

   KEY MEANING
   === =======
   h   Connect to host
   P   Port number to use for connection
   S   Socket file to use for connection
   u   User for login if not current user
   p   Password to use when connecting
   F   Only read default options from the given file

If you omit any values in the sibling or uncle host, they are filled in with defaults from the slave host, so you don't need to specify them in both places. "mk-slave-move" reads all normal MySQL option files, such as ~/.my.cnf, so you may not need to specify username, password and other common options at all.

EXIT STATUS
Successful exit status is 0. Any other value represents the exit status of the Perl process itself.

OPTIONS
Specify one and only one of "--sibling-of-master", "--slave-of-sibling", "--slave-of-uncle", or "--detach".

--ask-pass
    Prompt for a password when connecting to MySQL.

--charset
    short form: -A; type: string

    Default character set. If the value is utf8, sets Perl's binmode on STDOUT to utf8, passes the mysql_enable_utf8 option to DBD::mysql, and runs SET NAMES UTF8 after connecting to MySQL. Any other value sets binmode on STDOUT without the utf8 layer, and runs SET NAMES after connecting to MySQL.

--config
    type: Array

    Read this comma-separated list of config files; if specified, this must be the first option on the command line.

--defaults-file
    short form: -F; type: string

    Only read mysql options from the given file. You must give an absolute pathname.

--detach
    Make this server forget that it is a slave.

--help
    Show help and exit.

--host
    short form: -h; type: string

    Connect to host.

--password
    short form: -p; type: string

    Password to use when connecting.

--pid
    type: string

    Create the given PID file. The file contains the process ID of the script. The PID file is removed when the script exits. Before starting, the script checks if the PID file already exists. If it does not, then the script creates and writes its own PID to it. If it does, then the script checks the following: if the file contains a PID and a process is running with that PID, then the script dies; or, if there is no process running with that PID, then the script overwrites the file with its own PID and starts; else, if the file contains no PID, then the script dies.

--port
    short form: -P; type: int

    Port number to use for connection.

--set-vars
    type: string; default: wait_timeout=10000

    Set these MySQL variables. Immediately after connecting to MySQL, this string will be appended to SET and executed.

--sibling-of-master
    Make the server a slave of its grandparent, so it is a sibling of its master.

    The procedure is as follows:

     1. Connect to the server's master.
     2. Stop the slave processes on the master.
     3. Wait for the server to catch up to its master in replication.
     4. Point the slave to the master's master.

--slave-of-sibling
    Make the server a slave of one of its siblings. Specify the sibling as a DSN.

    The procedure is as follows:

     1. Connect to the sibling and verify that it has the same master.
     2. Stop the slave processes on the server and its sibling.
     3. If one of the servers is behind the other, make it catch up.
     4. Point the slave to its sibling.

--slave-of-uncle
    Make the server a slave of one of its uncles (parent's siblings). Specify the uncle as a DSN.

    An "uncle" is a sibling of the server's master. The procedure is as follows:

     1. Connect to the slave's master and its uncle, and verify that both have the
        same master.  (Their common master is the slave's grandparent).
     2. Stop the slave processes on the master and uncle.
     3. If one of them is behind the other, make it catch up.
     4. Point the slave to its uncle.

--socket
    short form: -S; type: string

    Socket file to use for connection.

--timeout
    type: time; default: 10m

    Timeout when waiting for replication to catch up.

--user
    short form: -u; type: string

    User for login if not current user.

--version
    Show version and exit.

DSN OPTIONS
These DSN options are used to create a DSN. Each option is given like "option=value". The options are case-sensitive, so P and p are not the same option. There cannot be whitespace before or after the "=" and if the value contains whitespace it must be quoted. DSN options are comma-separated. See the maatkit manpage for full details.

•   A

    dsn: charset; copy: yes

    Default character set.

•   D

    dsn: database; copy: yes

    Default database.

•   F

    dsn: mysql_read_default_file; copy: yes

    Only read default options from the given file

•   h

    dsn: host; copy: yes

    Connect to host.

•   p

    dsn: password; copy: yes

    Password to use when connecting.

•   P

    dsn: port; copy: yes

    Port number to use for connection.

•   S

    dsn: mysql_socket; copy: yes

    Socket file to use for connection.

•   u

    dsn: user; copy: yes

    User for login if not current user.

DOWNLOADING
You can download Maatkit from Google Code at <http://code.google.com/p/maatkit/>, or you can get any of the tools easily with a command like the following:

   wget http://www.maatkit.org/get/toolname
   or
   wget http://www.maatkit.org/trunk/toolname

Where "toolname" can be replaced with the name (or fragment of a name) of any of the Maatkit tools. Once downloaded, they're ready to run; no installation is needed. The first URL gets the latest released version of the tool, and the second gets the latest trunk code from Subversion.

ENVIRONMENT
The environment variable "MKDEBUG" enables verbose debugging output in all of the Maatkit tools:

   MKDEBUG=1 mk-....

SYSTEM REQUIREMENTS
You need Perl, DBI, DBD::mysql, and some core packages that ought to be installed in any reasonably new version of Perl.

BUGS
For list of known bugs see <http://www.maatkit.org/bugs/mk-slave-move>.

Please use Google Code Issues and Groups to report bugs or request support: <http://code.google.com/p/maatkit/>. You can also join #maatkit on Freenode to discuss Maatkit.

Please include the complete command-line used to reproduce the problem you are seeing, the version of all MySQL servers involved, the complete output of the tool when run with "--version", and if possible, debugging output produced by running with the "MKDEBUG=1" environment variable.

COPYRIGHT, LICENSE AND WARRANTY
This program is copyright 2007-2010 Baron Schwartz. Feedback and improvements are welcome.

THIS PROGRAM IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2; OR the Perl Artistic License. On UNIX and similar systems, you can issue `man perlgpl' or `man perlartistic' to read these licenses.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

SEE ALSO
See also mk-table-checksum, mk-table-sync, mk-slave-delay.

AUTHOR
Baron Schwartz

ABOUT MAATKIT
This tool is part of Maatkit, a toolkit for power users of MySQL. Maatkit was created by Baron Schwartz; Baron and Daniel Nichter are the primary code contributors. Both are employed by Percona. Financial support for Maatkit development is primarily provided by Percona and its clients.

VERSION
This manual page documents Ver 0.9.11 Distrib 6224 $Revision: 6208 $.